/* computer/screen.h -- written by Alexis WILKE (c) 2005-2006 */

/**********************************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**********************************************************************/

#ifndef SCREEN_OUTPUT_H
#define SCREEN_OUTPUT_H


//#include	"emu65xx.h"
#include	<fltk/Image.h>
#include	<fltk/Widget.h>
#include	<fltk/events.h>

#include	<stdio.h>

void Keyboard(unsigned int key);


class ScreenOutput : public fltk::Widget
{
public:
	ScreenOutput(int a,int b,int c,int d,const char*e =0)
		: Widget(a, b, c, d ,e)
	{
	}
	virtual void draw(void)
	{
		fltk::Rectangle rect(0, 0, 40 * 7 * zoom_, 24 * 8 * zoom_);
		image_->draw(rect, 0, 0);
	}
	void image(fltk::Image *image) { image_ = image; }
	void zoom(int zoom) { zoom_ = zoom; }
	virtual int handle(int event)
	{
		const char	*text;
		unsigned char	key;

		switch(event) {
		case fltk::FOCUS:
			// we want the focus!
			return 1;

		case fltk::KEY:
			// send the key to the Apple emulator
			text = fltk::event_text();
			while((key = *text) != '\0') {
				if(key <= 0x7F) {
					Keyboard(key);
				}
				text++;
			}
			return 0;

		case fltk::PUSH:
		case fltk::ENTER:
			take_focus();
			break;

		}
		return Widget::handle(event);
	}
private:
	fltk::Image	*image_;
	int		zoom_;
};



#endif
//#ifndef SCREEN_OUTPUT_H
