/* emu65xx.h -- written by Alexis WILKE (c) 2005-2006 */

/**********************************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**********************************************************************/


#include	"emu.h"

//#include	<stdio.h>
//#include	<stdlib.h>
//#include	<string.h>

namespace emulator_8bits
{



void emu65C02::Push(unsigned char v)
{
	f_callback.OnStore(f_regs.f_s + 0x100, v);
	--f_regs.f_s;
}


void emu65C02::PushWord(unsigned short w)
{
	Push(w >> 8);
	Push(w);
}


unsigned char emu65C02::Pop(void)
{
	unsigned char	v;

	++f_regs.f_s;
	f_callback.OnLoad(f_regs.f_s + 0x100, v);

	return v;
}


unsigned short emu65C02::PopWord(void)
{
	unsigned char a, b;
	a = Pop();
	b = Pop();
	return a + (b << 8);
}




unsigned char emu65C02::Load(unsigned short addr)
{
	unsigned short	a;
	unsigned char	v;

	++f_stats.f_read;
	a = addr >> 8;
	if((f_stats.f_page_read[a / 8] & (1 << (a & 7))) == 0) {
		++f_stats.f_page_read_count;
		f_stats.f_page_read[a / 8] |= 1 << (a & 7);
	}

	f_callback.OnLoad(addr, v);

	return v;
}



unsigned short emu65C02::LoadWord(unsigned short addr)
{
	return Load(addr) + (Load(addr + 1) << 8);
}


unsigned short emu65C02::LoadWordRound(unsigned short addr)
{
	if((addr & 255) == 255) {
		return Load(addr) + (Load(addr & ~255) << 8);
	}
	return LoadWord(addr);
}


void emu65C02::Store(unsigned short addr, unsigned char v)
{
	unsigned short		a;

	++f_stats.f_write;
	a = addr >> 8;
	if((f_stats.f_page_written[a / 8] & (1 << (a & 7))) == 0) {
		++f_stats.f_page_written_count;
		f_stats.f_page_written[a / 8] |= 1 << (a & 7);
	}

	f_callback.OnStore(addr, v);
}




void emu65C02::SetLoadFlags(unsigned char v)
{
	f_regs.f_p.f_zero = !v;
	f_regs.f_p.f_negative = v >> 7;
}






};			// namespace emulator_8bits
// vim: ts=8
